//
//  main.m
//  Students
//
//  Created by Ken Anderson on 8/30/11.
//  Copyright 2011 University of Colorado, Boulder. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Student.h"
#import "Undergraduate.h"
#import "MastersStudent.h"
#import "PhDStudent.h"


int main (int argc, const char * argv[])
{

    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

    NSMutableArray* students = [[NSMutableArray alloc] initWithCapacity:7];
    
    [students addObject:[[[Undergraduate alloc] initWithName:@"Bilbo Baggins"] autorelease]];
    [students addObject:[[[Undergraduate alloc] initWithName:@"Samwise Gamgee"] autorelease]];
    [students addObject:[[[MastersStudent alloc] initWithName:@"Aargorn"] autorelease]];
    [students addObject:[[[MastersStudent alloc] initWithName:@"Gimli"] autorelease]];
    [students addObject:[[[MastersStudent alloc] initWithName:@"Legolas"] autorelease]];
    [students addObject:[[[PhDStudent alloc] initWithName:@"Gandalf the White"] autorelease]];
    [students addObject:[[[PhDStudent alloc] initWithName:@"Sauron the Dark Lord"] autorelease]];

    for (Student* s in students) {
        NSLog(@"%@", s);
    }
    
    NSLog(@"\n");
    
    for (Student* s in students) {
        [s saySomething];
    }
    
    [students release];
    
    [pool drain];
    return 0;
}

